import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class SchoolTest
{
    @Test
    public void testAVGAlter2()
    {
        School s;
        Student max, susi, maria, alex;

        s = new School();
        max = new Student("Max", 29, true);
        susi = new Student("Susi", 16, false);
        maria = new Student("Maria", 22, true);
        alex = new Student("Alex", 25, true);
        assertEquals(-999.0, s.avgAlter(), 0.0001);

        s.aufnehmen(max);
        assertEquals(29.0, s.avgAlter(), 0.0001);

        s.aufnehmen(susi);
        assertEquals(22.5, s.avgAlter(), 0.0001);

        s.aufnehmen(maria);
        assertEquals(22.333333, s.avgAlter(), 0.0001);

        s.aufnehmen(alex);
        assertEquals(23.0, s.avgAlter(), 0.0001);
    }

    @Test
    public void testLoschen2()
    {
        School s;
        Student max, susi, maria, alex;

        s = new School();
        max   = new Student("Max",   29, true);
        susi  = new Student("Susi",  16, false);
        maria = new Student("Maria", 22, true);
        alex  = new Student("Alex",  25, true);

        s.loschen(0);
        s.loschen(-1);
        s.aufnehmen(max);
        s.aufnehmen(susi);
        s.aufnehmen(maria);
        s.aufnehmen(alex);
        s.loschen(1);
        assertEquals(true, s.contains(max));
        assertEquals(true, s.contains(maria));
        assertEquals(true, s.contains(alex));
        assertEquals(false, s.contains(susi));
        s.loschen(2);
        assertEquals(true, s.contains(max));
        assertEquals(true, s.contains(maria));
        assertEquals(false, s.contains(alex));
        assertEquals(false, s.contains(susi));
    }

    @Test
    public void testSearchName2()
    {
        School s;
        Student max, susi, maria, alex;

        s = new School();
        max   = new Student("Max",   29, true);
        susi  = new Student("Susi",  16, false);
        maria = new Student("Maria", 22, true);
        alex  = new Student("Alex",  25, true);

        assertEquals(null, s.search("Max"));
        s.aufnehmen(max);
        assertEquals(max, s.search("Max"));
        s.aufnehmen(susi);
        s.aufnehmen(maria);
        s.aufnehmen(alex);
        assertEquals(max, s.search("Max"));
        assertEquals(susi, s.search("Susi"));
        assertEquals(alex, s.search("aLeX"));
    }

    @Test
    public void testLoschenName()
    {
        School s;
        Student max, susi, maria, alex, max2;

        s = new School();
        max   = new Student("Max",   29, true);
        susi  = new Student("Susi",  16, false);
        maria = new Student("Maria", 22, true);
        alex  = new Student("Alex",  25, true);
        max2  = new Student("Max",   15, false);

        s.loschen("Max");       // Fehler
        s.aufnehmen(max);
        s.aufnehmen(susi);
        s.aufnehmen(maria);
        s.aufnehmen(alex);
        s.aufnehmen(max2);
        s.loschen("Andrea");    // Fehler
        s.loschen("mArIA");
        assertEquals(true, s.contains(max));
        assertEquals(true, s.contains(susi));
        assertEquals(true, s.contains(alex));
        assertEquals(true, s.contains(max2));
        assertEquals(false, s.contains(maria));
        s.loschen("Susi");
        assertEquals(true, s.contains(max));
        assertEquals(true, s.contains(alex));
        assertEquals(true, s.contains(max2));
        assertEquals(false, s.contains(maria));
        assertEquals(false, s.contains(susi));
        s.loschen("Max");
        assertEquals(true, s.contains(alex));
        assertEquals(true, s.contains(max2));
        assertEquals(false, s.contains(maria));
        assertEquals(false, s.contains(susi));
        assertEquals(false, s.contains(max));
    }

    @Test
    public void testMinAlter()
    {
        School s;
        Student max, susi, maria, alex, max2;

        s = new School();
        max   = new Student("Max",   29, true);
        susi  = new Student("Susi",  16, false);
        maria = new Student("Maria", 22, true);
        alex  = new Student("Alex",  25, true);
        max2  = new Student("Max",   15, false);

        assertEquals(null, s.minAlter());       // Fehler
        s.aufnehmen(max);
        assertEquals(max, s.minAlter());
        s.aufnehmen(susi);
        assertEquals(susi, s.minAlter());
        s.aufnehmen(maria);
        assertEquals(susi, s.minAlter());
        s.aufnehmen(alex);
        assertEquals(susi, s.minAlter());
        s.aufnehmen(max2);
        assertEquals(max2, s.minAlter());
    }

    @Test
    public void testAnzahlAbend()
    {
        School s;
        Student max, susi, maria, alex, max2;

        s = new School();
        max   = new Student("Max",   29, true);
        susi  = new Student("Susi",  16, false);
        maria = new Student("Maria", 22, true);
        alex  = new Student("Alex",  25, true);
        max2  = new Student("Max",   15, false);

        assertEquals(0, s.anzahlAbend());
        s.aufnehmen(max);
        assertEquals(1, s.anzahlAbend());
        s.aufnehmen(susi);
        assertEquals(1, s.anzahlAbend());
        s.aufnehmen(maria);
        assertEquals(2, s.anzahlAbend());
        s.aufnehmen(alex);
        assertEquals(3, s.anzahlAbend());
        s.aufnehmen(max2);
        assertEquals(3, s.anzahlAbend());
    }
    /*
    @Test
    public void testConstructor()
    {
        School s;
        s = new School();
        assertEquals(5, 5);
    }

    @Test
    public void aufnehmen()
    {
        School s;
        Student max, susi, werner, karl, andrea;
        Student []sessel;

        s = new School();
        max    = new Student("Max",    29, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 17, false);
        karl   = new Student("Karl",   19, false);
        andrea = new Student("Andrea", 33, true);
        sessel = s.getSessel();
        assertEquals(null, sessel[0]);
        assertEquals(null, sessel[1]);
        assertEquals(null, sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(0, s.getAnzahl());

        s.aufnehmen(null);  //Fehler kein Student
        sessel = s.getSessel();
        assertEquals(null, sessel[0]);
        assertEquals(null, sessel[1]);
        assertEquals(null, sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(0, s.getAnzahl());

        s.aufnehmen(max);
        sessel = s.getSessel();
        assertEquals(max, sessel[0]);
        assertEquals(null, sessel[1]);
        assertEquals(null, sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(1, s.getAnzahl());

        s.aufnehmen(susi);
        sessel = s.getSessel();
        assertEquals(max, sessel[0]);
        assertEquals(susi, sessel[1]);
        assertEquals(null, sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(2, s.getAnzahl());

        s.aufnehmen(werner);
        sessel = s.getSessel();
        assertEquals(max, sessel[0]);
        assertEquals(susi, sessel[1]);
        assertEquals(werner, sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(3, s.getAnzahl());

        s.aufnehmen(karl);
        sessel = s.getSessel();
        assertEquals(max, sessel[0]);
        assertEquals(susi, sessel[1]);
        assertEquals(werner, sessel[2]);
        assertEquals(karl, sessel[3]);
        assertEquals(4, s.getAnzahl());

        s.aufnehmen(andrea);    //Fehler kein Platz
        sessel = s.getSessel();
        assertEquals(max, sessel[0]);
        assertEquals(susi, sessel[1]);
        assertEquals(werner, sessel[2]);
        assertEquals(karl, sessel[3]);
        assertEquals(4, s.getAnzahl());
    }

    @Test
    public void testAvgAlter()
    {
        School s;
        Student max, susi, werner, karl;

        s = new School();
        max    = new Student("Max",    29, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 17, false);
        karl   = new Student("Karl",   19, false);

        assertEquals(-999, s.avgAlter(), 0.1);

        s.aufnehmen(max);
        assertEquals(29, s.avgAlter(), 0.1);

        s.aufnehmen(susi);
        assertEquals(25.5, s.avgAlter(), 0.1);

        s.aufnehmen(werner);
        assertEquals(22.666666, s.avgAlter(), 0.1);

        s.aufnehmen(karl);
        assertEquals(21.75, s.avgAlter(), 0.1);
    }

    @Test
    public void testMaxAlter()
    {
        School s;
        Student max, susi, werner, karl;

        s = new School();
        max    = new Student("Max",    25, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 29, true);
        karl   = new Student("Karl",   19, false);

        assertEquals(null, s.maxAlter());

        s.aufnehmen(max);
        assertEquals(max, s.maxAlter());

        s.aufnehmen(susi);
        assertEquals(max, s.maxAlter());

        s.aufnehmen(werner);
        assertEquals(werner, s.maxAlter());

        s.aufnehmen(karl);
        assertEquals(werner, s.maxAlter());
    }

    @Test
    public void testEinfugen()
    {
        School s;
        Student max, susi, werner, karl, andrea;
        Student []sessel;

        s = new School();
        max    = new Student("Max",    29, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 17, false);
        karl   = new Student("Karl",   19, false);
        andrea = new Student("Andrea", 33, true);
        sessel = s.getSessel();

        assertEquals(null, sessel[0]);
        assertEquals(null, sessel[1]);
        assertEquals(null, sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(0, s.getAnzahl());

        s.einfugen(-1, max);                //Fehler
        assertEquals(null, sessel[0]);
        assertEquals(null, sessel[1]);
        assertEquals(null, sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(0, s.getAnzahl());

        s.einfugen(1, max);                //Fehler
        assertEquals(null, sessel[0]);
        assertEquals(null, sessel[1]);
        assertEquals(null, sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(0, s.getAnzahl());

        s.einfugen(0, max);
        assertEquals(max, sessel[0]);
        assertEquals(null, sessel[1]);
        assertEquals(null, sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(1, s.getAnzahl());

        s.einfugen(0, susi);
        assertEquals(susi, sessel[0]);
        assertEquals(max, sessel[1]);
        assertEquals(null, sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(2, s.getAnzahl());

        s.einfugen(1, werner);
        assertEquals(susi,   sessel[0]);
        assertEquals(werner, sessel[1]);
        assertEquals(max,    sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(3, s.getAnzahl());

        s.einfugen(1, null);                //Fehler
        assertEquals(susi,   sessel[0]);
        assertEquals(werner, sessel[1]);
        assertEquals(max,    sessel[2]);
        assertEquals(null, sessel[3]);
        assertEquals(3, s.getAnzahl());

        s.einfugen(0, karl);
        assertEquals(karl,   sessel[0]);
        assertEquals(susi,   sessel[1]);
        assertEquals(werner, sessel[2]);
        assertEquals(max,    sessel[3]);
        assertEquals(4, s.getAnzahl());

        s.einfugen(0, andrea);              //Fehler
        assertEquals(karl,   sessel[0]);
        assertEquals(susi,   sessel[1]);
        assertEquals(werner, sessel[2]);
        assertEquals(max,    sessel[3]);
        assertEquals(4, s.getAnzahl());
    }

    @Test
    public void testSortBubbleAlter()
    {
        School s;
        Student max, susi, werner, karl;
        Student[] sessel;

        s = new School();
        max = new Student("Max", 29, true);
        susi = new Student("Susi", 22, true);
        werner = new Student("Werner", 17, false);
        karl = new Student("Karl", 19, false);
        sessel = s.getSessel();

        s.aufnehmen(max);
        s.aufnehmen(susi);
        s.aufnehmen(werner);
        s.aufnehmen(karl);

        s.sortBubbleAlter();

        assertEquals(werner, sessel[0]);
        assertEquals(karl, sessel[1]);
        assertEquals(susi, sessel[2]);
        assertEquals(max, sessel[3]);
        assertEquals(4, s.getAnzahl());
    }

    @Test
    public void testSortBubbleName()
    {
        School s;
        Student max, susi, werner, karl;
        Student[] sessel;

        s = new School();
        max = new Student("Max", 29, true);
        susi = new Student("Susi", 22, true);
        werner = new Student("Werner", 17, false);
        karl = new Student("Karl", 19, false);
        sessel = s.getSessel();

        s.aufnehmen(max);
        s.aufnehmen(susi);
        s.aufnehmen(werner);
        s.aufnehmen(karl);

        s.sortBubbleName();

        assertEquals(karl,   sessel[0]);
        assertEquals(max,    sessel[1]);
        assertEquals(susi,   sessel[2]);
        assertEquals(werner, sessel[3]);
        assertEquals(4, s.getAnzahl());
        System.out.println(s);
    }
*/
}

