import org.junit.jupiter.api.Test;

import java.util.ArrayList;

import static org.junit.jupiter.api.Assertions.*;

class SchoolTest2
{
    @Test
    public void testAvgAlter()
    {
        School s;
        Student max, susi, werner, karl;

        s = new School();
        max    = new Student("Max",    29, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 17, false);
        karl   = new Student("Karl",   19, false);

        assertEquals(-999, s.avgAlter(), 0.1);

        s.aufnehmen(max);
        assertEquals(29, s.avgAlter(), 0.1);

        s.aufnehmen(susi);
        assertEquals(25.5, s.avgAlter(), 0.1);

        s.aufnehmen(werner);
        assertEquals(22.666666, s.avgAlter(), 0.1);

        s.aufnehmen(karl);
        assertEquals(21.75, s.avgAlter(), 0.1);
    }

    @Test
    public void testAufnehmen()
    {
        School s;
        Student max, susi, werner, karl, andrea;

        s = new School();
        max    = new Student("Max",    29, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 17, false);
        karl   = new Student("Karl",   19, false);
        andrea = new Student("Andrea", 33, true);

        System.out.println(s);
        System.out.println("======================");

        s.aufnehmen(null);  //Fehler kein Student
        System.out.println(s);
        System.out.println("======================");

        s.aufnehmen(max);
        System.out.println(s);
        System.out.println("======================");     // Max

        s.aufnehmen(susi);
        System.out.println(s);
        System.out.println("======================");     // Max Susi

        s.aufnehmen(werner);
        System.out.println(s);
        System.out.println("======================");     // Max Susi Werner

        s.aufnehmen(karl);
        System.out.println(s);
        System.out.println("======================");     // Max Susi Werner Karl

        s.aufnehmen(andrea);
        System.out.println(s);
        System.out.println("======================");     // Max Susi Werner Karl Andrea

        s.aufnehmen(max);                                 // Fehler schon in der Schule
        System.out.println(s);
        System.out.println("======================");     // Max Susi Werner Karl Andrea
    }

    @Test
    public void testMaxAlter()
    {
        School s;
        Student max, susi, werner, karl, andrea;

        s = new School();
        max    = new Student("Max",    25, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 29, true);
        karl   = new Student("Karl",   19, false);
        andrea = new Student("Andrea", 29, true);

        assertEquals(null, s.maxAlter());

        s.aufnehmen(max);
        assertEquals(max, s.maxAlter());

        s.aufnehmen(susi);
        assertEquals(max, s.maxAlter());

        s.aufnehmen(werner);
        assertEquals(werner, s.maxAlter());

        s.aufnehmen(karl);
        assertEquals(werner, s.maxAlter());

        s.aufnehmen(andrea);
        assertEquals(werner, s.maxAlter());
    }

    @Test
    public void testLoschen()
    {
        School s;
        Student max, susi, werner, karl, andrea;

        s = new School();
        max    = new Student("Max",    25, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 29, true);
        karl   = new Student("Karl",   19, false);
        andrea = new Student("Andrea", 29, true);

        s.loschen(0);           // Fehler ungültige Pos!
        System.out.println(s);      //
        System.out.println("=============================");
        s.aufnehmen(max);
        s.aufnehmen(susi);
        s.aufnehmen(werner);
        s.aufnehmen(karl);
        s.aufnehmen(andrea);
        System.out.println(s);      // Max Susi Werner Karl Andrea
        System.out.println("=============================");
        s.loschen(0);
        System.out.println(s);      // Susi Werner Karl Andrea
        System.out.println("=============================");
        s.loschen(2);
        System.out.println(s);      // Susi Werner Andrea
        System.out.println("=============================");
        s.loschen(-1);          // Fehler
        System.out.println(s);      // Susi Werner Andrea
        System.out.println("=============================");
        s.loschen(2);
        System.out.println(s);      // Susi Werner
        System.out.println("=============================");
        s.loschen(2);          // Fehler
        System.out.println(s);      // Susi Werner
        System.out.println("=============================");

    }

    @Test
    public void testLoschen2()
    {
        School s;
        Student max, susi, werner, karl, andrea;
        ArrayList<Student> sessel;

        s = new School();
        max    = new Student("Max",    25, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 29, true);
        karl   = new Student("Karl",   19, false);
        andrea = new Student("Andrea", 29, true);

        sessel = s.getSessel();

        s.loschen(0);           // Fehler ungültige Pos!
        assertEquals(0, sessel.size());
        System.out.println("=============================");
        s.aufnehmen(max);
        s.aufnehmen(susi);
        s.aufnehmen(werner);
        s.aufnehmen(karl);
        s.aufnehmen(andrea);
        assertEquals(5, sessel.size());
        assertEquals(true, sessel.contains(max));
        assertEquals(true, sessel.contains(susi));
        assertEquals(true, sessel.contains(werner));
        assertEquals(true, sessel.contains(karl));
        assertEquals(true, sessel.contains(andrea));
        System.out.println("=============================");
        s.loschen(0);
        assertEquals(4, sessel.size());
        assertEquals(false, sessel.contains(max));
        assertEquals(true, sessel.contains(susi));
        assertEquals(true, sessel.contains(werner));
        assertEquals(true, sessel.contains(karl));
        assertEquals(true, sessel.contains(andrea));
        System.out.println("=============================");
        s.loschen(2);
        assertEquals(3, sessel.size());
        assertEquals(false, sessel.contains(max));
        assertEquals(true, sessel.contains(susi));
        assertEquals(true, sessel.contains(werner));
        assertEquals(false, sessel.contains(karl));
        assertEquals(true, sessel.contains(andrea));
        System.out.println("=============================");
        s.loschen(-1);          // Fehler
        assertEquals(3, sessel.size());
        assertEquals(false, sessel.contains(max));
        assertEquals(true, sessel.contains(susi));
        assertEquals(true, sessel.contains(werner));
        assertEquals(false, sessel.contains(karl));
        assertEquals(true, sessel.contains(andrea));
        System.out.println("=============================");
        s.loschen(2);
        assertEquals(2, sessel.size());
        assertEquals(false, sessel.contains(max));
        assertEquals(true, sessel.contains(susi));
        assertEquals(true, sessel.contains(werner));
        assertEquals(false, sessel.contains(karl));
        assertEquals(false, sessel.contains(andrea));
        System.out.println("=============================");
        s.loschen(2);          // Fehler
        assertEquals(2, sessel.size());
        assertEquals(false, sessel.contains(max));
        assertEquals(true, sessel.contains(susi));
        assertEquals(true, sessel.contains(werner));
        assertEquals(false, sessel.contains(karl));
        assertEquals(false, sessel.contains(andrea));
        System.out.println("=============================");
    }

    @Test
    public void testSearch()
    {
        School s;
        Student max, susi, werner, karl, andrea;

        s = new School();
        max    = new Student("Max",    25, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 29, true);
        karl   = new Student("Karl",   19, false);
        andrea = new Student("Andrea", 29, true);

        assertEquals(null, s.search("Max"));            // Fehler

        s.aufnehmen(max);
        s.aufnehmen(susi);
        s.aufnehmen(werner);
        s.aufnehmen(karl);
        s.aufnehmen(andrea);

        assertEquals(max, s.search("Max"));
        assertEquals(andrea, s.search("Andrea"));
        assertEquals(null, s.search("Franz"));          // Fehler
    }

    @Test
    public void testLoschenName()
    {
        School s;
        Student max, susi, werner, karl, max2;
        ArrayList<Student> sessel;

        s = new School();
        max    = new Student("Max",    25, true);
        susi   = new Student("Susi",   22, true);
        werner = new Student("Werner", 29, true);
        karl   = new Student("Karl",   19, false);
        max2   = new Student("Max", 29, true);

        sessel = s.getSessel();

        s.aufnehmen(max);
        s.aufnehmen(susi);
        s.aufnehmen(werner);
        s.aufnehmen(karl);
        s.aufnehmen(max2);

        s.loschen("Max");

        assertEquals(3, s.getAnzahl());
        assertEquals(true, sessel.contains(susi));
        assertEquals(true, sessel.contains(werner));
        assertEquals(true, sessel.contains(karl));

        assertEquals(false, sessel.contains(max));
        assertEquals(false, sessel.contains(max2));
    }
}